/**
 * 
 */
package org.vamsas.client.simpleclient;

import java.io.DataInput;
import java.io.DataOutput;
import java.util.Vector;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;
import org.vamsas.client.IClientAppdata;
import org.vamsas.objects.core.AppData;
import org.vamsas.objects.core.ApplicationData;
import org.vamsas.objects.core.User;
import org.vamsas.objects.utils.AppDataReference;

/**
 * @author jimp
 * Access interface to data chunks read from a VamsasArchiveReader stream 
 * (or byte buffer input stream) or written to a VamsasArchive stream.
 */
public class SimpleClientAppdata implements IClientAppdata {
  private static Log log = LogFactory.getLog(SimpleClientAppdata.class);

  ClientDocument clientdoc;
  /**
   * state flags
   * - accessed ClientAppdata
   * - accessed UserAppdata
   * => inputStream from embedded xml or jar entry of backup has been created
   * - set ClientAppdata
   * - set UserAppdata
   * => an output stream has been created and written to - or a data chunk has been written.
   *  - need flag for switching between embedded and jar entry mode ? - always write a jar entry for a stream.
   *  - need code for rewind and overwriting if the set*Appdata methods are called more than once.
   *  - need flags for streams to except a call to set*Appdata when an output stream exists and is open.
   *  - need 
   * @param clientdoc The ClientDocument instance that this IClientAppData is accessing
   */
  protected SimpleClientAppdata(ClientDocument clientdoc) {
    if (clientdoc==null) {
      log.fatal("Implementation error - Null ClientDocument for SimpleClientAppdata construction.");
      throw new Error("Implementation error - Null ClientDocument for SimpleClientAppdata construction.");
    }
    this.clientdoc = clientdoc;
  }
  /**
   * gets appropriate app data for the application, if it exists in this dataset
   * 
   */
  private void extractAppData() {
    org.vamsas.objects.core.VamsasDocument doc = null;
    Vector apldataset = AppDataReference.getUserandApplicationsData(
        doc, clientdoc.sclient.getUserHandle(), clientdoc.sclient.getClientHandle());
    ApplicationData appsglobal=null;
    User usersdata = null;
    if (apldataset!=null) {
      if (apldataset.size()>0) {
        AppData clientdat = (AppData) apldataset.get(0);
        if (clientdat instanceof ApplicationData) {
          appsglobal = (ApplicationData) clientdat;
          if (apldataset.size()>1) {
            clientdat = (AppData) apldataset.get(1);
            if (clientdat instanceof User)
              usersdata = (User) clientdat;
            if (apldataset.size()>2)
              log.info("Ignoring additional ("+(apldataset.size()-2)+") AppDatas returned by document appdata query.");
          } 
        } else {
          log.warn("Unexpected entry in AppDataReference query: id="+clientdat.getVorbaId()+" type="+clientdat.getClass().getName());
        }
      }
    }
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#getClientAppdata()
   */
  public byte[] getClientAppdata() {
    // TODO Auto-generated method stub
    return null;
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#getClientInputStream()
   */
  public DataInput getClientInputStream() {
    // TODO Auto-generated method stub
    return null;
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#getClientOutputStream()
   */
  public DataOutput getClientOutputStream() {
    // TODO Auto-generated method stub
    return null;
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#getUserAppdata()
   */
  public byte[] getUserAppdata() {
    // TODO Auto-generated method stub
    return null;
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#getUserInputStream()
   */
  public DataInput getUserInputStream() {
    // TODO Auto-generated method stub
    return null;
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#getUserOutputStream()
   */
  public DataOutput getUserOutputStream() {
    // TODO Auto-generated method stub
    return null;
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#hasClientAppdata()
   */
  public boolean hasClientAppdata() {
    // TODO Auto-generated method stub
    return false;
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#hasUserAppdata()
   */
  public boolean hasUserAppdata() {
    // TODO Auto-generated method stub
    return false;
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#setClientAppdata(byte[])
   */
  public void setClientAppdata(byte[] data) {
    // TODO Auto-generated method stub
    
  }

  /* (non-Javadoc)
   * @see org.vamsas.client.IClientAppdata#setUserAppdata(byte[])
   */
  public void setUserAppdata(byte[] data) {
    // TODO Auto-generated method stub
    
  }
  /* (non-Javadoc)
   * @see java.lang.Object#finalize()
   */
  protected void finalize() throws Throwable {
    // TODO Auto-generated method stub
    super.finalize();
  }

}
